package com.unis.crk.cplbusiness.controller;

import cn.hutool.json.JSONObject;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.unis.crk.aop.SystemLog;
import com.unis.crk.cplbusiness.entity.DataCrkywCplzjjgDefault;
import com.unis.crk.cplbusiness.entity.vo.DataCrkywCplzjjgDefaultVo;
import com.unis.crk.cplbusiness.service.IDataCrkywCplzjjgDefaultService;
import com.unis.crk.utils.ResultUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.ObjectUtils;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 质检机构 前端控制器
 * </p>
 *
 * @author ghh
 * @since 2022-09-14
 */
@Api(value = "质检机构",tags = {"质检机构"})
@RestController
@RequestMapping("dataCrkywCplzjjgDefault")
public class DataCrkywCplzjjgDefaultController {

    private final static Logger LOGGER = LoggerFactory.getLogger(DataCrkywCplzjjgDefaultController.class);


    @Autowired
    private IDataCrkywCplzjjgDefaultService dataCrkywCplzjjgDefaultService;


    /**
     * 根据ID查询数据
     * @param id
     * @return
     */
    @ApiOperation(value="查询", notes="根据ID查询数据")
    @GetMapping("getOne/{id}")
    public ResultUtil getOne(@PathVariable("id") String id){
        LOGGER.info("入参为:{}",id);
        ResultUtil<DataCrkywCplzjjgDefault> data = new ResultUtil<>();
        if (StringUtils.isEmpty(id)){
            data.failed("传入的主键为空");
            return data;
        }
        data.success(this.dataCrkywCplzjjgDefaultService.getById(id));
        return data;
    }

    /**
     *获取质检机构下拉
     * @param unitId
     * @return
     */
    @ApiOperation(value="查询", notes="通过单位Id查询质检机构拉列表")
    @GetMapping({"/getZjjgList/{unitId}"})
    public ResultUtil getZjjgList(@PathVariable(value = "unitId",required = false) String unitId) {
        ResultUtil<List<Map<String,Object>>> data = new ResultUtil<>();
        data.success(this.dataCrkywCplzjjgDefaultService.getZjjgList(unitId));
        return data;
    }
    /**
         * 分页高级查询
         * @return
         */
    @ApiOperation(value="查询", notes="分页高级查询")
    @PostMapping(value="/findPage")
    public ResultUtil findPage(@RequestBody DataCrkywCplzjjgDefaultVo pageQuery) {
        ResultUtil<IPage<Map<String,Object>>> data = new ResultUtil<>();
        data.success(this.dataCrkywCplzjjgDefaultService.findPageVo(pageQuery));
        return data;
    }
    /**
     * 新增一条数据
     * @param entity
     * @return
     */
    @ApiOperation(value="新增", notes="新增一条数据")
    @PostMapping("add")
    public ResultUtil add(@RequestBody DataCrkywCplzjjgDefault entity){
        LOGGER.info("入参为:{}", entity);
        ResultUtil<Boolean> data = new ResultUtil<>();
        if (ObjectUtils.isEmpty(entity)){
            data.failed("所接收对象为null");
            return data;
        }
        JSONObject ret  = this.dataCrkywCplzjjgDefaultService.add(entity);
        if (ret.getBool("success")){
        data.success(ret.getStr("msg"));
        }else {
        data.failed(ret.getStr("msg"));
        }

        return data;
    }


    /**
     * 修改一条数据
     * @param entity
     * @return
     */
    @ApiOperation(value="修改", notes="修改一条数据")
    @PatchMapping("edit")
    public ResultUtil edit(@RequestBody  DataCrkywCplzjjgDefault entity){
        LOGGER.info("入参为:{}", entity);
        ResultUtil<Boolean> data = new ResultUtil<>();
        if (ObjectUtils.isEmpty(entity)){
        data.failed("所接收对象为null");
        return data;
        }
        JSONObject ret  = this.dataCrkywCplzjjgDefaultService.update(entity);
        if (ret.getBool("success")){
        data.success(ret.getStr("msg"));
        }else {
        data.failed(ret.getStr("msg"));
        }

        return data;
    }


    /**
     * 根据ID删除数据
     * @param id
     * @return
     */
    @ApiOperation(value="删除", notes="根据ID删除数据")
    @DeleteMapping("delete/{id}")
    public ResultUtil delete(@PathVariable("id") String id){
        LOGGER.info("入参为:{}", id);
        ResultUtil<Boolean> data = new ResultUtil<>();
        if (StringUtils.isEmpty(id)){
            data.failed("所接收id为null");
            return data;
        }
        JSONObject ret  = this.dataCrkywCplzjjgDefaultService.delete(id);
        if (ret.getBool("success")){
        data.success(ret.getStr("msg"));
        }else {
        data.failed(ret.getStr("msg"));
        }
        return data;
    }


}

